hdu 3032 Nim or not Nim?(博弈 SG)

Nim is a two-player mathematic game of strategy in which players take turns removing objects from distinct heaps. On each turn, a player must remove at least one object, and may remove any number of objects provided they all come from the same heap.

Nim is usually played as a misere game, in which the player to take the last object loses. Nim can also be played as a normal play game, which means that the person who makes the last move (i.e., who takes the last object) wins. This is called normal play because most games follow this convention, even though Nim usually does not.

Alice and Bob is tired of playing Nim under the standard rule, so they make a difference by also allowing the player to separate one of the heaps into two smaller ones. That is, each turn the player may either remove any number of objects from a heap or separate a heap into two smaller ones, and the one who takes the last object wins.

Input
Input contains multiple test cases. The first line is an integer 1 ≤ T ≤ 100, the number of test cases. Each case begins with an integer N, indicating the number of the heaps, the next line contains N integers s[0], s[1], …., s[N-1], representing heaps with s[0], s[1], …, s[N-1] objects respectively.(1 ≤ N ≤ 10^6, 1 ≤ S[i] ≤ 2^31 - 1)

Output
For each test case, output a line which contains either “Alice” or “Bob”, which is the winner of this game. Alice will play first. You may asume they never make mistakes.
Sample Input

2
3
2 2 3
2
3 3

Sample Output

Alice
Bob

题解:
题意:有n堆石子,两个人轮流选一个石堆拿若干石头或将其中一堆分成两小堆,谁先取完谁赢

咳咳,现在轮到重头戏,sg打表找规律喽~
(不知道sg函数的转https://blog.csdn.net/ling_wang/article/details/80644805
sg[0]=0

sg[1] = mex{sg[0] } = 1

sg[2] = mex{sg[0], sg[1], sg[1, 1] } = mex{0, 1, sg[1]^sg[1]} = 2;

sg[3] = mex{sg[0], sg[1], sg[2], sg[1, 2]} = mex{0, 1, 2, 1^2} = mex{0, 1, 2, 3} = 4;

sg[4] = mex{sg[0], sg[1], sg[2], sg[3], sg[1, 3], sg[2, 2]} = mex{0, 1, 2, 4, 2, 0} = 3;

sg[5] = mex{sg[0], sg[1], sg[2], sg[3], sg[4], sg[1, 4], sg[2, 3]} = mex{0, 1, 2, 4, 3, 2, 1} = 5;
.
.
.

so,我们可以发现
sg[4*k+1]=4*k+1, sg[4*k+2]=4*k+2, sg[4*k+3]=4*k+4, sg[4*k+4]=4*k+3

然后就可以写代码了~

#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
const int N = 1e6 + 10;

int getsg(int x){
    if(x == 0)      return x;//因为0%任何数都为0,将该情况单列
    if(x%4 == 3)    return x+1;
    if(x%4 == 0)    return x-1;
    return x;
}


int main(){
    int T, n;
    ll ans, t;
    scanf("%d", &T);
    while(T--){
        ans = 0;
        scanf("%d", &n);
        while(n--){
            scanf("%lld", &t);
            ans ^= getsg(t);
        }
        if(ans)
            printf("Alice\n");
        else
            printf("Bob\n");
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/ling_wang/article/details/81304358